package hu.elte.inf.teralg;

/**
 * Térinformatikai algoritmusok
 * Alapvető adatszerkezetek
 * @author Máté Cserép <mcserep@inf.elte.hu>
 */
public class BasicDataStructures {

    public static void main(String[] args) {
        // === VEREM === //
        MyStack<String> stack = new MyStack<String>();
        stack.push("alma");
        stack.push("citrom");
        stack.push("barack");
        stack.push("körte");
        stack.push("eper");
        stack.push("dió");

        System.out.println("Verem:");
        while(!stack.empty()) {
            System.out.println(stack.pop());
        }
        System.out.println();


        // === SOR === //
        MyQueue<String> queue = new MyQueue<String>();
        queue.push("alma");
        queue.push("citrom");
        queue.push("barack");
        queue.push("körte");
        queue.push("eper");
        queue.push("dió");

        System.out.println("Sor:");
        while(!queue.empty()) {
            System.out.println(queue.pop());
        }
        System.out.println();


        // === ELSŐBBSÉGI SOR === //
        MyPriorityQueue<String> prQueue = new MyPriorityQueue<String>();
        prQueue.push("alma");
        prQueue.push("citrom");
        prQueue.push("barack");
        prQueue.push("körte");
        prQueue.push("eper");
        prQueue.push("dió");

        System.out.println("Elsőbbségi sor:");
        while(!prQueue.empty()) {
            System.out.println(prQueue.pop());
        }
        System.out.println();


        // Java Class Library tartalmazza ezeket az adatszerkezeteket:
        //java.util.Stack;
        //java.util.Queue;
        //java.util.PriorityQueue
    }
}
