package hu.elte.inf.teralg;

/**
 * Verem adatszerkezet
 * @author Máté Cserép <mcserep@inf.elte.hu>
 */
public class MyStack<T> {
    // Láncolt listás reprezentáció
    private class Node {
        public T data;
        public Node next;

        public Node(T data, Node next) {
            this.data = data;
            this.next = next;
        }
    }

    // Első elem
    private Node head;

    // Új, üres verem létrehozása
    public MyStack() {
        head = null;
    }

    // Verembe
    public void push(T value) {
        head = new Node(value, head);
    }

    // Felső
    public T top() {
        if(head == null)
            throw new IllegalStateException("The stack is empty.");
        return head.data;
    }

    // Veremből
    public T pop() {
        if(head == null)
            throw new IllegalStateException("The stack is empty.");

        T result = head.data;
        head = head.next;
        return result;
    }

    // Üres-e
    public boolean empty() {
        return head == null;
    }
}
